[kvm-unit-tests PATCH v2 11/18] arm/run: Add support for kvmtool
Andrew Jones
andrew.jones at linux.dev
Wed Jan 22 03:50:02 AEDT 2025
On Mon, Jan 20, 2025 at 04:43:09PM +0000, Alexandru Elisei wrote:
> Teach the arm runner to use kvmtool when kvm-unit-tests has been configured
> appropriately.
>
> The test is ran using run_test_status() because kvmtool does not have a
> testdev device to return the test exit code, so kvm-unit-tests must always
> parse the "EXIT: STATUS" line for the exit code.
>
> Signed-off-by: Alexandru Elisei <alexandru.elisei at arm.com>
> ---
> arm/run | 183 ++++++++++++++++++++++++++++++++++----------------------
> 1 file changed, 110 insertions(+), 73 deletions(-)
>
> diff --git a/arm/run b/arm/run
> index 9b11feafffdd..880d5afae86d 100755
> --- a/arm/run
> +++ b/arm/run
> @@ -17,77 +17,114 @@ qemu)
> exit 3
> esac
>
> -processor="$PROCESSOR"
> +arch_run_qemu()
> +{
> + processor="$PROCESSOR"
> +
> + if [ "$QEMU" ] && [ -z "$ACCEL" ] &&
> + [ "$HOST" = "aarch64" ] && [ "$ARCH" = "arm" ] &&
> + [ "$(basename $QEMU)" = "qemu-system-arm" ]; then
> + ACCEL="tcg"
> + fi
> +
> + set_qemu_accelerator || exit $?
> + if [ "$ACCEL" = "kvm" ]; then
> + QEMU_ARCH=$HOST
> + fi
> +
> + qemu=$(search_qemu_binary) ||
> + exit $?
> +
> + if ! $qemu -machine '?' | grep -q 'ARM Virtual Machine'; then
> + echo "$qemu doesn't support mach-virt ('-machine virt'). Exiting."
> + exit 2
> + fi
> +
> + M='-machine virt'
> +
> + if [ "$ACCEL" = "kvm" ]; then
> + if $qemu $M,\? | grep -q gic-version; then
> + M+=',gic-version=host'
> + fi
> + fi
> +
> + if [ "$ACCEL" = "kvm" ] || [ "$ACCEL" = "hvf" ]; then
> + if [ "$HOST" = "aarch64" ] || [ "$HOST" = "arm" ]; then
> + processor="host"
> + if [ "$ARCH" = "arm" ] && [ "$HOST" = "aarch64" ]; then
> + processor+=",aarch64=off"
> + fi
> + fi
> + fi
> +
> + if [ "$ARCH" = "arm" ]; then
> + M+=",highmem=off"
> + fi
> +
> + if ! $qemu $M -device '?' | grep -q virtconsole; then
> + echo "$qemu doesn't support virtio-console for chr-testdev. Exiting."
> + exit 2
> + fi
> +
> + if ! $qemu $M -chardev '?' | grep -q testdev; then
> + echo "$qemu doesn't support chr-testdev. Exiting."
> + exit 2
> + fi
> +
> + if [ "$UEFI_SHELL_RUN" != "y" ] && [ "$EFI_USE_ACPI" != "y" ]; then
> + chr_testdev='-device virtio-serial-device'
> + chr_testdev+=' -device virtconsole,chardev=ctd -chardev testdev,id=ctd'
> + fi
> +
> + pci_testdev=
> + if $qemu $M -device '?' | grep -q pci-testdev; then
> + pci_testdev="-device pci-testdev"
> + fi
> +
> + A="-accel $ACCEL$ACCEL_PROPS"
> + command="$qemu -nodefaults $M $A -cpu $processor $chr_testdev $pci_testdev"
> + command+=" -display none -serial stdio"
> + command="$(migration_cmd) $(timeout_cmd) $command"
> +
> + if [ "$UEFI_SHELL_RUN" = "y" ]; then
> + ENVIRON_DEFAULT=n run_test_status $command "$@"
> + elif [ "$EFI_USE_ACPI" = "y" ]; then
> + run_test_status $command -kernel "$@"
> + else
> + run_qemu $command -kernel "$@"
> + fi
> +}
> +
> +arch_run_kvmtool()
> +{
> + local command
> +
> + kvmtool=$(search_kvmtool_binary) ||
> + exit $?
> +
> + if [ "$ACCEL" ] && [ "$ACCEL" != "kvm" ]; then
> + echo "kvmtool does not support $ACCEL" >&2
> + exit 2
> + fi
> +
> + if ! kvm_available; then
> + echo "KVM required by kvmtool but not available on the host" >&2
> + exit 2
> + fi
> +
> + command="$(timeout_cmd) $kvmtool run"
> + if [ "$HOST" = "aarch64" ] && [ "$ARCH" = "arm" ]; then
> + run_test_status $command --kernel "$@" --aarch32
> + else
> + run_test_status $command --kernel "$@"
> + fi
> +}
>
> -if [ "$QEMU" ] && [ -z "$ACCEL" ] &&
> - [ "$HOST" = "aarch64" ] && [ "$ARCH" = "arm" ] &&
> - [ "$(basename $QEMU)" = "qemu-system-arm" ]; then
> - ACCEL="tcg"
> -fi
> -
> -set_qemu_accelerator || exit $?
> -if [ "$ACCEL" = "kvm" ]; then
> - QEMU_ARCH=$HOST
> -fi
> -
> -qemu=$(search_qemu_binary) ||
> - exit $?
> -
> -if ! $qemu -machine '?' | grep -q 'ARM Virtual Machine'; then
> - echo "$qemu doesn't support mach-virt ('-machine virt'). Exiting."
> - exit 2
> -fi
> -
> -M='-machine virt'
> -
> -if [ "$ACCEL" = "kvm" ]; then
> - if $qemu $M,\? | grep -q gic-version; then
> - M+=',gic-version=host'
> - fi
> -fi
> -
> -if [ "$ACCEL" = "kvm" ] || [ "$ACCEL" = "hvf" ]; then
> - if [ "$HOST" = "aarch64" ] || [ "$HOST" = "arm" ]; then
> - processor="host"
> - if [ "$ARCH" = "arm" ] && [ "$HOST" = "aarch64" ]; then
> - processor+=",aarch64=off"
> - fi
> - fi
> -fi
> -
> -if [ "$ARCH" = "arm" ]; then
> - M+=",highmem=off"
> -fi
> -
> -if ! $qemu $M -device '?' | grep -q virtconsole; then
> - echo "$qemu doesn't support virtio-console for chr-testdev. Exiting."
> - exit 2
> -fi
> -
> -if ! $qemu $M -chardev '?' | grep -q testdev; then
> - echo "$qemu doesn't support chr-testdev. Exiting."
> - exit 2
> -fi
> -
> -if [ "$UEFI_SHELL_RUN" != "y" ] && [ "$EFI_USE_ACPI" != "y" ]; then
> - chr_testdev='-device virtio-serial-device'
> - chr_testdev+=' -device virtconsole,chardev=ctd -chardev testdev,id=ctd'
> -fi
> -
> -pci_testdev=
> -if $qemu $M -device '?' | grep -q pci-testdev; then
> - pci_testdev="-device pci-testdev"
> -fi
> -
> -A="-accel $ACCEL$ACCEL_PROPS"
> -command="$qemu -nodefaults $M $A -cpu $processor $chr_testdev $pci_testdev"
> -command+=" -display none -serial stdio"
> -command="$(migration_cmd) $(timeout_cmd) $command"
> -
> -if [ "$UEFI_SHELL_RUN" = "y" ]; then
> - ENVIRON_DEFAULT=n run_test_status $command "$@"
> -elif [ "$EFI_USE_ACPI" = "y" ]; then
> - run_test_status $command -kernel "$@"
> -else
> - run_qemu $command -kernel "$@"
> -fi
> +case "$TARGET" in
> +qemu)
> + arch_run_qemu "$@"
> + ;;
> +kvmtool)
> + arch_run_kvmtool "$@"
> + ;;
> +esac
> --
> 2.47.1
>
>
Reviewed-by: Andrew Jones <andrew.jones at linux.dev>
More information about the Linuxppc-dev
mailing list